#include "ElementVectors.h"
#include "ElementVectors.hpp"
using namespace tbox;

template class ElementVectors<double, static_cast<int>(ELTYPE::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TRI3), 3>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TRI3), 3>;

template class ElementVectors<double, static_cast<int>(ELTYPE::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::QUAD4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::QUAD4), 4>;

template class ElementVectors<double, static_cast<int>(ELTYPE::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TETRA4), 4>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::TETRA4), 4>;

template class ElementVectors<double, static_cast<int>(ELTYPE::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 8, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 16, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::HEX8), 8>;
template class ElementVectors<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int, double, 32, Kokkos::OpenMP>>, static_cast<int>(ELTYPE::HEX8), 8>;
