#ifndef RANDOMVARIABLE_H
#define RANDOMVARIABLE_H

#include "katropton.h"
#include "wGroup.h"
#include <vector>

namespace katropton
{

class KATROPTON_API RandomVariable
{
public:
  std::vector<double> values;

  RandomVariable(Problem &pbl, std::vector<double> _values) : values(_values)
  {
    pbl.RandomVariables.push_back(this);
  };
};
} // namespace katropton

#endif //RANDOMVARIABLE_H
