#include "Tpetra_Vector.hpp"
#include "Kokkos_ViewFactory.hpp"
#include "Tpetra_Map.hpp"
#include <mpi.h>
#include "Tpetra_CrsGraph.hpp"
#include <Epetra_Map.h>

#include "Tpetra_ConfigDefs.hpp"

#include "Tpetra_Map.hpp"
#include "Tpetra_MultiVector.hpp"
#include "Tpetra_Vector.hpp"
#include "Tpetra_CrsGraph.hpp"
#include "Tpetra_CrsMatrix.hpp"

Teuchos::RCP<Tpetra::CrsMatrix<>> compute_M_D(const Tpetra::Vector<>::local_ordinal_type numMyContacts,
                                              Kokkos::View<int **, Kokkos::LayoutRight> mesh_Contacts,
                                              Kokkos::View<double **, Kokkos::LayoutRight> mesh_Nodes,
                                              Kokkos::View<int **, Kokkos::LayoutRight> mesh_Elems,
                                              const Tpetra::Vector<>::local_ordinal_type Contacts_slave_nodes,
                                              const Tpetra::Vector<>::local_ordinal_type Contacts_slave_elems,
                                              const Tpetra::Vector<>::local_ordinal_type Contacts_master_nodes,
                                              const Tpetra::Vector<>::local_ordinal_type Contacts_master_elems,
                                              Teuchos::RCP<const Tpetra::Map<>> mapNodes,
                                              Teuchos::RCP<const Tpetra::Map<>> mapNodesWO,
                                              Teuchos::RCP<const Tpetra::Map<>> mapElems,
                                              Epetra_Map map00,
                                              const Tpetra::Vector<>::local_ordinal_type numNodes,
                                              const Tpetra::Vector<>::local_ordinal_type numDPN,
                                              Teuchos::RCP<Tpetra::Vector<Tpetra::Vector<>::global_ordinal_type, Tpetra::Vector<>::local_ordinal_type, Tpetra::Vector<>::global_ordinal_type>> &lagrange_msh0,
                                              bool signorini,
                                              MPI_Comm comm);
